package	jp.co.sds_corp.streaming;

import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.WindowEvent;

import javax.swing.Box;
import javax.swing.BoxLayout;
import javax.swing.ButtonGroup;
import javax.swing.JComboBox;
import javax.swing.JRadioButton;

import jp.co.sds_corp.util.pooh.dialog.DialogResource;
import jp.co.sds_corp.util.pooh.simple.SimpleButton;
import jp.co.sds_corp.util.pooh.simple.SimplePanel;

public class SetPair extends SimplePanel {
	String[] allPair = { "USDJPY", "EURUSD", "EURJPY",
					"GBPUSD", "GBPJPY", "AUDUSD", "AUDJPY" };
	int[] allPrec = { 2, 4, 2, 4, 2, 4, 2 };
	String[] allTerm = {
		"SP", "TOD", "TOM", "1W", "2W",
		"3W", "1M",  "2M",  "3M", "6M",
		"9M", "1Y",  "2Y",  "3Y",
	};
	JComboBox		CMB_PAIR = new JComboBox();
	JComboBox		CMB_TERM = new JComboBox();
	ButtonGroup		GRP = new ButtonGroup();
	JRadioButton	RD_TYPE1 = new JRadioButton( "Outright" );
	JRadioButton	RD_TYPE2 = new JRadioButton( "Graph" );
	JRadioButton	RD_TYPE3 = new JRadioButton( "Forward" );

	private class CmbPair
	{
		String	ccy1, ccy2;
		int		nPrec;
		CmbPair( String pair, int nPrec ) {
			this.ccy1 = pair.substring( 0, 3 );
			this.ccy2 = pair.substring( 3, 6 );
			this.nPrec = nPrec;
		}
		public String toString() {
			return ccy1 + "/" + ccy2;
		}
	}

	public boolean createPane() {
		setupCombo();
		setupRadio();

		Box box1 = new Box( BoxLayout.Y_AXIS );
		Box box2 = new Box( BoxLayout.X_AXIS );
		box2.add( CMB_PAIR );
		box2.add( CMB_TERM );
		box1.add( box2 );
		box1.add( RD_TYPE1 );
		box1.add( RD_TYPE2 );
		box1.add( RD_TYPE3 );
		add( box1 );

		setButton_id(0, SimpleButton.OK);
		setButton_id(1, SimpleButton.CANCEL);
		return true;
	}

	private void setupCombo() {
		for ( int i = 0; i < allPair.length; i++ ) {
			CMB_PAIR.addItem( new CmbPair( allPair[i], allPrec[i] ));
		}
		for ( int i = 0; i < allTerm.length; i++ ) {
			CMB_TERM.addItem( allTerm[i] );
		}
	}

	private void setupRadio() {
		RD_TYPE1.addActionListener( new ActionListener() {
			public void actionPerformed( ActionEvent e ) {
				CMB_TERM.setEnabled( true );
			}
		} );
		RD_TYPE2.addActionListener( new ActionListener() {
			public void actionPerformed( ActionEvent e ) {
				CMB_TERM.setEnabled( true );
			}
		} );
		RD_TYPE3.addActionListener( new ActionListener() {
			public void actionPerformed( ActionEvent e ) {
				CMB_TERM.setEnabled( false );
			}
		} );
		GRP.add( RD_TYPE1 );
		GRP.add( RD_TYPE2 );
		GRP.add( RD_TYPE3 );
		RD_TYPE1.setSelected( true );
	}

	public void setValue( String ccy1, String ccy2, String term ) {
		for ( int i = 0; i < CMB_PAIR.getItemCount(); i++ ) {
			CmbPair pair = (CmbPair )CMB_PAIR.getItemAt( i );
			if ( pair.ccy1.equals( ccy1 ) && pair.ccy2.equals( ccy2 )) {
				CMB_PAIR.setSelectedIndex( i );
				break;
			}
		}
		CMB_TERM.setSelectedItem( term );
	}

	public void closed() {
	}
	public void doSystemBtnClose(WindowEvent e) {
	}

	public void doAction(int idx) {
		try {
			DialogResource request = (DialogResource)getResource();
			request.setUserAttribute("STREAMING_NEW");
			CmbPair selPair = (CmbPair )CMB_PAIR.getSelectedItem();
			String selTerm = (String )CMB_TERM.getSelectedItem();
			toplevel.setUserAttribute("STREAMING_NEW", "CCY1", selPair.ccy1 );
			toplevel.setUserAttribute("STREAMING_NEW", "CCY2", selPair.ccy2 );
			toplevel.setUserAttribute("STREAMING_NEW", "PREC", String.valueOf( selPair.nPrec ));
			toplevel.setUserAttribute("STREAMING_NEW", "TERM", selTerm );
			if ( RD_TYPE1.isSelected()) {
				toplevel.setUserAttribute("STREAMING_NEW", "TYPE", "Outright" );
			} else if ( RD_TYPE2.isSelected()) {
				toplevel.setUserAttribute("STREAMING_NEW", "TYPE", "Chart" );
			} else if ( RD_TYPE3.isSelected()) {
				toplevel.setUserAttribute("STREAMING_NEW", "TYPE", "Forward" );
			}
			super.doAction(idx);	// 必ず最後にこれをコールしてください
		} catch (Exception e) { e.printStackTrace(); }
	}
}
